﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class tab_sample : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            ViewState["sort_order"] = "";

            for (int i = 0; i < WebTab1.Tabs.Count; i++)
            {
                WebTab1.Tabs[i].MarginTrailing = 3;
            }

            loadContent("");
        }

    }

    private void loadContent(string sort_order)
    {
        chart_global.DataSource = buildGlobalDataSample();
        chart_global.DataBind();
        dataGrid_global.DataSource = buildGlobalDataSample();
        dataGrid_global.DataBind();

        chart_region.DataSource = buildRegionDataSample(sort_order);
        chart_region.DataBind();
        dataGrid_region.DataSource = buildRegionDataSample(sort_order);
        dataGrid_region.DataBind();

        chart_centers.DataSource = buildCenterDataSample(sort_order);
        chart_centers.DataBind();
        dataGrid_centers.DataSource = buildCenterDataSample(sort_order);
        dataGrid_centers.DataBind();
    }



    protected void WebTab1_SelectedIndexChanged(object sender, Infragistics.Web.UI.LayoutControls.TabSelectedIndexChangedEventArgs e)
    {
        if (ViewState["sort_order"] != null)
        {
            string str = (string)ViewState["sort_order"];
            loadContent(str);
        }
        else
            loadContent("");
    }
    protected void dataGrid_centers_ColumnSorted(object sender, Infragistics.Web.UI.GridControls.SortingEventArgs e)
    {
        string str = dataGrid_centers.Columns[e.Column.Index].Key;
        loadContent(str);
    }
    protected void dataGrid_region_ColumnSorted(object sender, Infragistics.Web.UI.GridControls.SortingEventArgs e)
    {
        string str = dataGrid_region.Columns[e.Column.Index].Key;
        loadContent(str);
    }

    protected void dataGrid_global_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
    {
        e.Row.Items[0].Column.Width = 150;

        for (int i = 1; i < e.Row.Items.Count; i++)
        {
            try
            {
                if (e.Row.Items[0].Text.Contains("%"))
                    e.Row.Items[i].Text = decimal.Parse(e.Row.Items[i].Text).ToString("P1").Replace(".00", "");
                else
                    e.Row.Items[i].Text = decimal.Parse(e.Row.Items[i].Text).ToString("N0").Replace(".00", "");
            }
            catch { }
        }
    }
    protected void dataGrid_region_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
    {
        for (int i = 1; i < e.Row.Items.Count; i++)
        {
            try
            {


                if (i.Equals(5) || i.Equals(6) || i.Equals(7))
                {
                    e.Row.Items[i].Text = decimal.Parse(e.Row.Items[i].Text).ToString("P1").Replace(".00", "");
                }
                else
                {
                    e.Row.Items[i].Text = decimal.Parse(e.Row.Items[i].Text).ToString("N0").Replace(".00", "");
                }
            }
            catch { }
        }
    }
    protected void dataGrid_centers_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
    {
        for (int i = 1; i < e.Row.Items.Count; i++)
        {
            try
            {


                if (i.Equals(5) || i.Equals(6) || i.Equals(7))
                {
                    e.Row.Items[i].Text = decimal.Parse(e.Row.Items[i].Text).ToString("P1").Replace(".00", "");
                }
                else
                {
                    e.Row.Items[i].Text = decimal.Parse(e.Row.Items[i].Text).ToString("N0").Replace(".00", "");
                }
            }
            catch { }
        }
    }

    protected void chart_global_Click(object sender, ImageMapEventArgs e)
    {
        loadContent("");
    }
    protected void chart_region_Click(object sender, ImageMapEventArgs e)
    {
        loadContent("");
    }
    protected void chart_centers_Click(object sender, ImageMapEventArgs e)
    {
        loadContent("");
    }


    private DataTable buildGlobalDataSample()
    {
        DataTable dt = new DataTable();

        dt.Columns.Add("MONTH",typeof(string));
        dt.Columns.Add("DESIGN CAPACITY", typeof(decimal));
        dt.Columns.Add("CONTRACTED", typeof(decimal));
        dt.Columns.Add("TARGET", typeof(decimal));
        dt.Columns.Add("UTILIZED", typeof(decimal));
        dt.Columns.Add("Contracted vs Design %", typeof(decimal));
        dt.Columns.Add("Utilized vs Design %", typeof(decimal));
        dt.Columns.Add("Utilized vs Contracted %", typeof(decimal));

        dt.Rows.Add("Jan 2013", 145078, 128026, 183668, 68187, 0.8825, 0.4700, 0.5326);
        dt.Rows.Add("Feb 2013", 145078, 130577, 183947, 65053, 0.9001, 0.4484, 0.4982);
        dt.Rows.Add("Mar 2013", 145078, 132117, 184663, 65519, 0.9107, 0.4516, 0.4959);
        dt.Rows.Add("Apr 2013", 145078, 132406, 201735, 66524, 0.9127, 0.4585, 0.5024);

        return dt;
    }

    private DataTable buildRegionDataSample(string sort_order)
    {
        DataTable dt = new DataTable();

        dt.Columns.Add("RANKING", typeof(int));
        dt.Columns.Add("REGION", typeof(string));
        dt.Columns.Add("DESIGN CAPACITY", typeof(decimal));
        dt.Columns.Add("CONTRACTED", typeof(decimal));
        dt.Columns.Add("TARGET", typeof(decimal));
        dt.Columns.Add("UTILIZED", typeof(decimal));
        dt.Columns.Add("Contracted vs Design %", typeof(decimal));
        dt.Columns.Add("Utilized vs Design %", typeof(decimal));
        dt.Columns.Add("Utilized vs Contracted %", typeof(decimal));

        dt.Rows.Add(null,"East", 49733, 40298, 58435, 21218, 0.8103, 0.4266, 0.5265);
        dt.Rows.Add(null, "Central", 39247, 36635, 54640, 18177, 0.9335, 0.4631, 0.4962);
        dt.Rows.Add(null, "West", 43864, 41320, 54688, 22292, 0.9420, 0.5082, 0.5395);
        dt.Rows.Add(null, "EMEA", 11056, 9444, 15690, 4635, 0.8542, 0.4192, 0.4908);
        dt.Rows.Add(null, "Asia", 4776, 3023, 8389, 1028, 0.6331, 0.2152, 0.3400);

        if (!sort_order.Equals("") && !sort_order.Equals("region"))
        {
            DataView dv = dt.DefaultView;

            if(sort_order.Equals("design"))
                dv.Sort = "DESIGN CAPACITY";
            else if (sort_order.Equals("contracted"))
                dv.Sort = "CONTRACTED";
            else if (sort_order.Equals("target"))
                dv.Sort = "TARGET";
            else if (sort_order.Equals("utilized"))
                dv.Sort = "UTILIZED";
            else if (sort_order.Equals("percent_contacted_design"))
                dv.Sort = "Contracted vs Design %";
            else if (sort_order.Equals("percent_utilized_design"))
                dv.Sort = "Utilized vs Design %";
            else if (sort_order.Equals("percent_utilized_contracted"))
                dv.Sort = "Utilized vs Contracted %";

            DataTable dt_temp = dv.ToTable();

            for (int i = 0; i < dt_temp.Rows.Count; i++)
            {
                dt_temp.Rows[i]["RANKING"] = dt_temp.Rows.Count - i;
            }

            return dt_temp;
        }
        else
            return dt;
    }

    private DataTable buildCenterDataSample(string sort_order)
    {
        DataTable dt = new DataTable();

        dt.Columns.Add("RANKING", typeof(int));
        dt.Columns.Add("IDC", typeof(string));
        dt.Columns.Add("DESIGN CAPACITY", typeof(decimal));
        dt.Columns.Add("CONTRACTED", typeof(decimal));
        dt.Columns.Add("TARGET", typeof(decimal));
        dt.Columns.Add("UTILIZED", typeof(decimal));
        dt.Columns.Add("Contracted vs Design %", typeof(decimal));
        dt.Columns.Add("Utilized vs Design %", typeof(decimal));
        dt.Columns.Add("Utilized vs Contracted %", typeof(decimal));

        dt.Rows.Add(null, "Center #1", 49733, 40298, 58435, 21218, 0.8103, 0.4266, 0.5265);
        dt.Rows.Add(null, "Center #2", 39247, 36635, 54640, 18177, 0.9335, 0.4631, 0.4962);
        dt.Rows.Add(null, "Center #3", 43864, 41320, 54688, 22292, 0.9420, 0.5082, 0.5395);
        dt.Rows.Add(null, "Center #4", 11056, 9444, 15690, 4635, 0.8542, 0.4192, 0.4908);
        dt.Rows.Add(null, "Center #5", 4776, 3023, 8389, 1028, 0.6331, 0.2152, 0.3400);

        if (!sort_order.Equals("") && !sort_order.Equals("idc"))
        {
            DataView dv = dt.DefaultView;

            if (sort_order.Equals("design"))
                dv.Sort = "DESIGN CAPACITY";
            else if (sort_order.Equals("contracted"))
                dv.Sort = "CONTRACTED";
            else if (sort_order.Equals("target"))
                dv.Sort = "TARGET";
            else if (sort_order.Equals("utilized"))
                dv.Sort = "UTILIZED";
            else if (sort_order.Equals("percent_contacted_design"))
                dv.Sort = "Contracted vs Design %";
            else if (sort_order.Equals("percent_utilized_design"))
                dv.Sort = "Utilized vs Design %";
            else if (sort_order.Equals("percent_utilized_contracted"))
                dv.Sort = "Utilized vs Contracted %";

            DataTable dt_temp = dv.ToTable();

            for (int i = 0; i < dt_temp.Rows.Count; i++)
            {
                dt_temp.Rows[i]["RANKING"] = dt_temp.Rows.Count - i;
            }

            return dt_temp;
        }
        else
            return dt;
    }
}